<?php

	class pdate extends plugin	{
		public function __construct()	{
			parent::__construct();
			global $C;
			require_once($C->PLUGINS_DIR.'pdate/system/pdate.php');
			date_default_timezone_set('Asia/Tehran');
		}
		public function parse_date($timestamp, $return_words='auto', $return_dt_format='%Y/%m/%e - %H:%M')	{
			if( $return_words == FALSE ) {
				return pstrftime($return_dt_format, $timestamp);
			}
			$time	= time() - $timestamp;
			$year	= floor($time / 31536000);
			$time	-= $year * 31536000;
			$month	= floor($time / 2628000);
			$time	-= $month * 2628000;
			$day	= floor($time / 86400);
			$time	-= $day * 86400;
			$h	= floor($time / 3600);
			$time	-= $h * 3600;
			$m	= floor($time / 60);
			$time	-= $m * 60;
			$s	= $time;
			$txt	= '##BEFORE## ';
			if( $year > 0 ) {
				$txt	.= $year;
				$txt	.= $year==1 ? ' ##YEAR##' : ' ##YEARS##';
			}
			if( $month > 0 ) {
				if( $year > 0 ) {
					$txt	.= ' ##AND## ';
				}
				$txt	.= $month;
				$txt	.= $month==1 ? ' ##MONTH##' : ' ##MONTHS##';
			}
			if( $day > 0 ) {
				if( $month > 0 || $year > 0) {
					$txt	.= ' ##AND## ';
				}
				$txt	.= $day;
				$txt	.= $day==1 ? ' ##DAY##' : ' ##DAYS##';
			}
			if( $h > 0 ) {
				if( $day > 0 || $month > 0 || $year > 0) {
					$txt	.= ' ##AND## ';
				}
				$txt	.= $h;
				$txt	.= $h==1 ? ' ##HOUR##' : ' ##HOURS##';
			}
			if( $m > 0 ) {
				if( $h > 0 || $day > 0 || $month > 0 || $year > 0) {
					$txt	.= ' ##AND## ';
				}
				$txt	.= $m;
				$txt	.= $m==1 ? ' ##MIN##' : ' ##MINS##';
			}
			if( $h==0 && $m==0 ) {
				$txt	.= $s;
				$txt	.= $s==1 ? ' ##SEC##' : ' ##SECS##';
			}
			$txt	.= ' ##AGO##';
			return $this->parse_date_replace_strings($txt);
		}
		public function parse_date_replace_strings($txt='')		{
			$tmp	= array (
				'##BEFORE##'	=> '',
				'##YEAR##'	=> 'سال',
				'##YEARS##'	=> 'سال',
				'##MONTH##'	=> 'ماه',
				'##MONTHS##'	=> 'ماه',
				'##DAY##'	=> 'روز',
				'##DAYS##'	=> 'روز',
				'##HOUR##'		=> 'ساعت',
				'##HOURS##'		=> 'ساعت',
				'##MIN##'		=> 'دقيقه',
				'##MINS##'		=> 'دقيقه',
				'##SEC##'		=> 'ثانيه',
				'##SECS##'		=> 'ثانيه',
				'##AND##'		=> 'و',
				'##AGO##'		=> 'قبل',
				'##NOW##'		=> '1 ثانیه قبل',
			);
			$txt	= str_replace(array_keys($tmp), array_values($tmp), $txt);
			$txt	= trim($txt);
			$txt	= str_replace(' ', '&nbsp;', $txt);
			return $txt;
		}
		public function onPostLoad( &$var ) {
			if( $this->getCurrentController() == 'view' ) {
				$this->setVar('activity_permlink', '<a href="'.$var[0]->permalink.'" class="permlink">'.pstrftime('%Y/%m/%d - %H:%M',$var[0]->post_date).'</a>', 'replace');
			}else{
				$this->setVar('activity_permlink', '<a href="'.$var[0]->permalink.'" class="permlink">'.$this->parse_date($var[0]->post_date).'</a>', 'replace');
			}
			//$this->setVar('activity_footer','<a href="" class="add-comment action" data-value="'.htmlentities('{"activities_type":"'.$var[0]->post_type.'","activities_id":"'.$var[0]->post_id.'"}').'" data-role="services" data-namespace="comments" data-action="activityAddComment">دیدگاه</a>','replace');
		}
		public function onPostCommentLoad( &$var ) {
			if( $this->getCurrentController() == 'view' ) {
				$this->setVar('activity_comment_date', pstrftime('%Y/%m/%d - %H:%M',$var[0]->comment_date), 'replace' );
			}else{
				$this->setVar('activity_comment_date', $this->parse_date($var[0]->comment_date), 'replace' );
			}
		}
		public function onPageLoad(){
			global $C, $page;
			$data_value = ($page->params->group)? '{"activities_type": "group", "activities_group":"'.$page->params->group.'"}' : '{"activities_type": "dashboard"}';
			$this->setVar('editor_btn_placeholder', '<a class="status-btn post-btn btn blue" id="sendpost-effect" data-value="'.htmlentities($data_value).'" data-role="services" data-namespace="activities" data-action="set"><span>انتشار</span></a>', 'replace');
		}
	}